import { RequestOptionsArgs, Response } from '@angular/http';
import { Http } from '@angular/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs/Observable';
import 'rxjs/add/operator/map';
//import * as $ from 'jquery';
import { Card } from "../models/card";
import { TokenisedCard } from '../models/tokenised-card';
import { Registration } from "../models/registration";
import { CountryMobilePaymentOption } from "../models/country-mobile-payment-option";
import { TransactionToken } from "../models/transaction-token";
var DirectPayOnline = /** @class */ (function () {
    function DirectPayOnline(http) {
        this.http = http;
        console.log('Hello BopoProvider Provider');
    }
    /**
     *
     */
    /**
         *
         */
    DirectPayOnline.prototype.chargeTokenMobile = /**
         *
         */
    function (phoneNumber, paymentName, country, transactionToken) {
        var requestStr = "<?xml version='1.0' encoding='utf-8'?> \
    <API3G> \
      <CompanyToken>" + this.companyToken + "</CompanyToken> \
      <Request>ChargeTokenMobile</Request> \
      <TransactionToken>" + transactionToken + "</TransactionToken> \
      <PhoneNumber>" + phoneNumber + "</PhoneNumber> \
      <MNO>" + paymentName + "</MNO> \
      <MNOcountry>" + country + "</MNOcountry> \
    </API3G>";
        console.log("request str" + requestStr);
        this.http.post(this.v6_url, requestStr).map(function (res) { return res.text(); }).subscribe(function (res) {
            //console.log("res: " + res);
            var re = new RegExp('<br>', 'g');
            var res2 = res.replace(re, "");
            var parser = new DOMParser();
            var xmlDoc = parser.parseFromString(res2, "text/xml");
            console.log(xmlDoc);
            var statusCode = xmlDoc.getElementsByTagName("StatusCode")[0].childNodes[0].nodeValue;
            if (statusCode == "130") {
                // success
                return xmlDoc.getElementsByTagName("instructions")[0].childNodes[0].nodeValue;
            }
            else {
                // error
                return xmlDoc.getElementsByTagName("ResultExplanation")[0].childNodes[0].nodeValue;
            }
            //return "";
        });
    };
    /**
     * getMobilePaymentOptions():
     * Gets all registered mobile payment options for this merchant.
     */
    /**
         * getMobilePaymentOptions():
         * Gets all registered mobile payment options for this merchant.
         */
    DirectPayOnline.prototype.getMobilePaymentOptionsTS = /**
         * getMobilePaymentOptions():
         * Gets all registered mobile payment options for this merchant.
         */
    function (transactionToken) {
        var _this = this;
        var requestStr = "<?xml version='1.0' encoding='utf-8'?> \
    <API3G> \
      <CompanyToken>" + this.companyToken + "</CompanyToken> \
      <Request>GetMobilePaymentOptions</Request> \
      <TransactionToken>" + transactionToken + "</TransactionToken> \
    </API3G>";
        this.http.post(this.v5_url, requestStr).map(function (res) { return _this.convert.xml2js(res.text(), { compact: true, spaces: 4 }); }).subscribe(function (res) {
            //console.log("payOptions: " + payOptions.API3G.paymentoptions.mobileoption[0].country._text);
            var mobileOpts = res.API3G.paymentoptions.mobileoption;
            mobileOpts = _this.groupMobilePaymentByCountry(mobileOpts);
            _this.mobileMoneyOptions = _this.removeDuplicatesBy(function (country) { return country.name; }, mobileOpts);
            console.log(JSON.stringify(_this.mobileMoneyOptions));
            return _this.mobileMoneyOptions;
        });
    };
    /**
     *
     */
    /**
         *
         */
    DirectPayOnline.prototype.createTransactionToken = /**
         *
         */
    function (amount, currency, serviceType) {
        var _this = this;
        // First get the serivces for the provider
        var today = new Date();
        var todayStr = today.getFullYear() + '/' + (today.getMonth() + 1) + '/' + today.getDate() + ' ' + today.getHours() + ':' + today.getMinutes();
        console.log("Today str: " + todayStr);
        var requestStr = "<?xml version='1.0' encoding='utf-8'?> \
    <API3G> \
        <CompanyToken>" + this.companyToken + "</CompanyToken> \
        <Request>createToken</Request> \
        <Transaction> \
            <PaymentAmount>" + amount + "</PaymentAmount> \
            <PaymentCurrency>" + currency + "</PaymentCurrency> \
            <CompanyRef>49FKEOA</CompanyRef> \
            <RedirectURL></RedirectURL> \
            <BackURL></BackURL> \
            <CompanyRefUnique>0</CompanyRefUnique> \
            <PTL></PTL> \
        </Transaction> \
        <Services> \
            <Service> \
                <ServiceType>" + serviceType + "</ServiceType> \
                    <ServiceDescription>Service</ServiceDescription> \
                <ServiceDate>" + todayStr + "</ServiceDate> \
            </Service> \
        </Services> \
    </API3G>";
        return this.http.post(this.v5_url, requestStr).map(function (res) { return _this.convert.xml2js(res.text(), { compact: true, spaces: 4 }); });
    };
    DirectPayOnline.prototype.getServicesForProvider = function () {
        var _this = this;
        var servicesReqStr = "<?xml version='1.0' encoding='utf-8'?> \
    <API3G> \
      <Request>getServices</Request> \
      <CompanyToken>" + this.companyToken + "</CompanyToken> \
      <ProviderToken></ProviderToken> \
    </API3G>";
        return this.http.post(this.v5_url, servicesReqStr).map(function (res) { return _this.convert.xml2js(res.text(), { compact: true, spaces: 4 }); });
    };
    DirectPayOnline.prototype.createTransToken = function (amount, currency) {
        var _this = this;
        this.getServicesForProvider().subscribe(function (services) {
            var serviceID = services.API3G.Services.Service[0].ServiceID._text;
            console.log("ServiceID: " + serviceID);
            _this.createTransactionToken(amount, currency, "" + serviceID).subscribe(function (res) {
                console.log(JSON.stringify(res));
                return res;
            });
        });
    };
    //#region CARD TRANSACTIONS
    //#region CARD TRANSACTIONS
    DirectPayOnline.prototype.tokeniseCard = 
    //#region CARD TRANSACTIONS
    function (card, customerToken) {
        var _this = this;
        var tokeniseCardRequestXML = "<?xml version='1.0' encoding='utf-8'?> \
    <API3G> \
      <CompanyToken>" + this.companyToken + "</CompanyToken> \
      <Request>addCard</Request> \
      <customerToken>" + customerToken + "</customerToken> \
      <CustomerCreditCard>" + card.cardNumber + "</CustomerCreditCard> \
      <CustomerExpiry>" + card.cardExpMonth + card.cardExpYear + "</CustomerExpiry> \
      <CustomerCvv>" + card.cardCVV + "</CustomerCvv> \
      <CustomerHolderName>" + card.cardHolderName + "</CustomerHolderName> \
    </API3G>";
        console.log(tokeniseCardRequestXML);
        this.http.post(this.v6_url, tokeniseCardRequestXML).map(function (res) { return _this.convert.xml2js(res.text(), { compact: true, spaces: 4 }); }).subscribe(function (res) {
            console.log(JSON.stringify(res));
            return res;
        });
    };
    DirectPayOnline.prototype.chargeCard = function (card, transToken) {
        var _this = this;
        var requestStr = "<?xml version='1.0' encoding='utf-8'?> \
    <API3G> \
        <CompanyToken>" + this.companyToken + "</CompanyToken> \
        <Request>chargeTokenRecurrent</Request> \
        <TransactionToken>" + transToken + "</TransactionToken> \
        <subscriptionToken>" + card.subscriptionToken + "</subscriptionToken> \
    </API3G>";
        console.log("charge card reg str: " + requestStr);
        this.http.post(this.v6_url, requestStr).map(function (res) { return _this.convert.xml2js(res.text(), { compact: true, spaces: 4 }); }).subscribe(function (res) {
            console.log(JSON.stringify(res));
            return res;
        });
    };
    DirectPayOnline.prototype.deleteCard = function (card, customerToken) {
        var _this = this;
        var requestStr = "<?xml version='1.0' encoding='utf-8'?>" +
            "<API3G>" +
            "<CompanyToken>" + this.companyToken + "</CompanyToken>" +
            "<Request>deleteCard</Request>" +
            "<customerToken>" + customerToken + "</customerToken>" +
            "<subscriptionToken>" + card.subscriptionToken + "</subscriptionToken>" +
            "</API3G>";
        return this.http.post(this.v6_url, requestStr).map(function (res) { return _this.convert.xml2js(res.text(), { compact: true, spaces: 4 }); });
    };
    //#endregion
    //#endregion
    DirectPayOnline.prototype.registerCustomer = 
    //#endregion
    function (registration) {
        var _this = this;
        var requestStr = "<API3G>" +
            "<CompanyToken>" + this.companyToken + "</CompanyToken>" +
            "<Request>createAccount</Request>" +
            "<CustomerEmail>" + registration.email + "</CustomerEmail>" +
            "<CustomerFirstName>" + registration.firstName + "</CustomerFirstName>" +
            "<CustomerLastName>" + registration.lastName + "</CustomerLastName>" +
            "<CustomerAddress>" + registration.address + "</CustomerAddress>" +
            "<CustomerCity>" + registration.city + "</CustomerCity>" +
            "<CustomerCountry>" + registration.countryCode + "</CustomerCountry>" +
            "<CustomerDialCode>" + registration.dialCode + "</CustomerDialCode>" +
            "<CustomerPhone>" + registration.phone + "</CustomerPhone>" +
            "<CustomerZip>" + registration.zip + "</CustomerZip>" +
            "<CustomerCreditCard>" + registration.creditCardNo + "</CustomerCreditCard>" +
            "<CustomerExpiry>" + registration.expiryMonth + registration.expiryYear + "</CustomerExpiry>" +
            "<CustomerCvv>" + registration.cvv + "</CustomerCvv>" +
            "<CustomerHolderName>" + registration.cardHolderName + "</CustomerHolderName>" +
            "</API3G>";
        console.log("register request str: " + requestStr);
        this.http.post(this.v6_url, requestStr).map(function (res) { return _this.convert.xml2js(res.text(), { compact: true, spaces: 4 }); }).subscribe(function (res) {
            console.log(JSON.stringify(res));
            return res;
        });
    };
    DirectPayOnline.prototype.removeDuplicatesBy = function (keyFn, array) {
        var mySet = new Set();
        return array.filter(function (x) {
            var key = keyFn(x), isNew = !mySet.has(key);
            if (isNew)
                mySet.add(key);
            return isNew;
        });
    };
    DirectPayOnline.prototype.groupMobilePaymentByCountry = function (jsObjects) {
        var opts = [];
        var countryMobilePaymentOption;
        jsObjects.forEach(function (mobileoption, i) {
            countryMobilePaymentOption = {
                name: mobileoption.country._text,
                countryCode: mobileoption.countryCode._text,
                currency: mobileoption.currency._text,
                cellularPrefix: mobileoption.celluarprefix._text,
                amount: mobileoption.amount._text,
                paymentProviders: [
                    {
                        name: mobileoption.paymentname._text,
                        instructions: mobileoption.instructions._text
                    }
                ]
            };
            jsObjects.forEach(function (mobileoption2, j) {
                if (!Object.is(mobileoption, mobileoption2)) {
                    if (mobileoption.country._text == mobileoption2.country._text) {
                        countryMobilePaymentOption.paymentProviders.push({
                            name: mobileoption2.paymentname._text,
                            instructions: mobileoption2.instructions._text
                        });
                    }
                }
            });
            opts.push(countryMobilePaymentOption);
            //console.log(JSON.stringify(countryMobilePaymentOption));
        });
        return opts;
    };
    return DirectPayOnline;
}());
export { DirectPayOnline };
//# sourceMappingURL=dpo.js.map